<?php
// wcf imports
require_once(WCF_DIR.'lib/system/cache/CacheBuilder.class.php');

/**
 * Caches the counter update types.
 * 
 * @author	Sebastian Oettl
 * @copyright	2009-2010 WCF Solutions <http://www.wcfsolutions.com/index.html>
 * @license	GNU Lesser General Public License <http://opensource.org/licenses/lgpl-license.php>
 * @package	com.wcfsolutions.wcf.acp.system.counterUpdate
 * @subpackage	system.cache
 * @category	Community Framework
 */
class CacheBuilderCounterUpdateTypes implements CacheBuilder {
	/**
	 * @see CacheBuilder::getData()
	 */
	public function getData($cacheResource) {
		list($cache, $packageID) = explode('-', $cacheResource['cache']); 
		$data = array();
		
		// get counter update type ids
		$typeIDArray = array();
		$sql = "SELECT		counterUpdateType, counterUpdateTypeID 
			FROM		wcf".WCF_N."_counter_update_type counter_update_type,
					wcf".WCF_N."_package_dependency package_dependency
			WHERE 		counter_update_type.packageID = package_dependency.dependency
					AND package_dependency.packageID = ".$packageID."
			ORDER BY	package_dependency.priority";
		$result = WCF::getDB()->sendQuery($sql);
		while ($row = WCF::getDB()->fetchArray($result)) {
			$typeIDArray[$row['counterUpdateType']] = $row['counterUpdateTypeID'];
		}
		
		// get counter update types
		if (count($typeIDArray) > 0) {
			$sql = "SELECT		counter_update_type.*, package.packageDir
				FROM		wcf".WCF_N."_counter_update_type counter_update_type
				LEFT JOIN	wcf".WCF_N."_package package
				ON		(package.packageID = counter_update_type.packageID)
				WHERE		counter_update_type.counterUpdateTypeID IN (".implode(',', $typeIDArray).")";
			$result = WCF::getDB()->sendQuery($sql);
			while ($row = WCF::getDB()->fetchArray($result)) {
				$row['className'] = StringUtil::getClassName($row['classFile']);
				$data[] = $row;
			}
		}
		
		return $data;
	}
}
?>