<?php

// wcf imports

require_once(WCF_DIR.'lib/data/rating/RateableObject.class.php');

require_once(WCF_DIR.'lib/system/cache/CacheBuilder.class.php');



/**

 * Caches rateable objects

 * 

 * @author	Alexander Ebert

 * @copyright	2001-2010 WoltLab GmbH

 * @license	GNU Lesser General Public License <http://opensource.org/licenses/lgpl-license.php>

 * @package	com.woltlab.wcf.rating

 * @subpackage	system.cache

 * @category 	Community Framework

 */

class CacheBuilderRateableObject implements CacheBuilder {

	/**

	 * @see	CacheBuilder::getData()

	 */

	public function getData($cacheResource) {

		$data = array();

		

		// get rateable objects

		$sql = "SELECT	*

			FROM	wcf".WCF_N."_rateable_object";

		$result = WCF::getDB()->sendQuery($sql);

		while ($row = WCF::getDB()->fetchArray($result)) {

			$objectName = $row['objectName'];

			

			if (!isset($data[$objectName])) {

				$data[$objectName] = array();

			}

			

			$data[$objectName][$row['packageID']] = new RateableObject(null, null, $row);

		}

		

		return $data;

	}

}

?>