<?php

// wcf imports

require_once(WCF_DIR.'lib/system/cache/CacheBuilder.class.php');

require_once(WCF_DIR.'lib/data/socialBookmark/SocialBookmarkProviderList.class.php');



/**

 * Caches social bookmark provider.

 * 

 * @author	Alexander Ebert

 * @copyright	2001-2010 WoltLab GmbH

 * @license	GNU Lesser General Public License <http://opensource.org/licenses/lgpl-license.php>

 * @package	com.woltlab.wcf.socialBookmarks

 * @subpackage	system.cache

 * @category 	Community Framework

 */

class CacheBuilderSocialBookmarkProvider implements CacheBuilder {

	/**

	 * @see	CacheBuilder::getData()

	 */

	public function getData($cacheResource) {

		$providerList = new SocialBookmarkProviderList();

		$providerList->sqlConditions = 'bookmark_provider.enabled = 1';

		$providerList->sqlOrderBy = 'bookmark_provider.showOrder ASC';

		$providerList->sqlLimit = 0;

		$providerList->readObjects();

		

		return $providerList->getObjects();

	}

}

?>